##############################################################################
#
#   555-BOOM! - An entry in the PyWeek 5 Game Programming Competition
#
#   By Gregory Ewing (greg.ewing@canterbury.ac.nz)
#
##############################################################################

import gc
from settings import screen_size, flags, get_command_line_options

def main():
	# PyGame must be initialised before importing any further modules
	# so that image loading will work properly.
	import pygame, pygame.mixer
	# Choice of buffer size seems to be critical for accurate sound timing.
	# 1102 is one 50ms frame time at 22050 samples/sec.
	pygame.mixer.pre_init(22050, -16, 1, 1102 // 8)
	pygame.init()
	try:
		pygame.mixer.init()
	except pygame.error:
		pass
	#print pygame.mixer.get_init()
	get_command_line_options()
	display = pygame.display.set_mode(screen_size, flags)
	from shell import FBShell
	shell = FBShell(display)
	gc.disable()
	shell.run()

if __name__ == "__main__":
	main()
